<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `src/main.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>main.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css"><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script src="../../storage.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="shortcut icon" href="../../favicon.ico"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../ch2_guessing_game/index.html'><div class='logo-container'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../settings.html"><img src="../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="comment">// Bring io library into scope</span>
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">io</span>;
<span class="kw">use</span> <span class="ident">rand</span>::<span class="ident">Rng</span>;

<span class="kw">fn</span> <span class="ident">main</span>() {
    <span class="comment">// Ask for user input</span>
    <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;Guess the number!&quot;</span>);
    <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;Please input your guess: &quot;</span>);

    <span class="comment">// Generate a number using the particular rand::thread_rng generator</span>
    <span class="comment">// - Local to current execution thread</span>
    <span class="comment">// - Seeded by the OS</span>
    <span class="kw">let</span> <span class="ident">secret_number</span> <span class="op">=</span> <span class="ident">rand</span>::<span class="ident">thread_rng</span>()
        .<span class="ident">gen_range</span>(<span class="number">1</span>, <span class="number">101</span>); <span class="comment">// Call gen_range() method to generate a random number</span>

    <span class="comment">// Create mutable String (UTF-8 encoded bits) to hold user input text</span>
    <span class="comment">// let -&gt; used to create a variable</span>
    <span class="comment">// mut -&gt; indicates variable is mutable (default is immutable)</span>
    <span class="comment">// :: -&gt; indicates that new is an associated function of the type String</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">input_guess</span> <span class="op">=</span> <span class="ident">String</span>::<span class="ident">new</span>();

    <span class="comment">// &amp; -&gt; indicates argument is a reference</span>
    <span class="comment">// &amp;mut -&gt; makes the reference data mutable (alternative would be &amp;input_guess</span>
    <span class="ident">io</span>::<span class="ident">stdin</span>()
        <span class="comment">// Returns a Result enum (Ok or Err) that encodes error handling information</span>
        <span class="comment">// Ok -&gt; operation successful, contains generated value</span>
        <span class="comment">// Err -&gt; operation failed, contains info about why</span>
        .<span class="ident">read_line</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">input_guess</span>) <span class="comment">// Returns a Result enum (Ok or Err)</span>
        .<span class="ident">expect</span>(<span class="string">&quot;Failed to read line!&quot;</span>); <span class="comment">// Returns this if Err, else returns Ok generated value</span>

    <span class="comment">// {} -&gt; value placeholder</span>
    <span class="macro">print</span><span class="macro">!</span>(<span class="string">&quot;You guessed: {}&quot;</span>, <span class="ident">input_guess</span>);
    <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;Secret number: {}&quot;</span>, <span class="ident">secret_number</span>)
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../";window.currentCrate = "ch2_guessing_game";</script><script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script><script defer src="../../search-index.js"></script></body></html>